export const imm = (obj) => {
    const t = Object.assign({}, obj);
    Object.freeze(t);
    return new Proxy(t, {
        get: (target, prop, receiver) => returnValue(target, prop, receiver),
        set: function () {
            return false;
        },
    });
};
function returnValue(target, prop, receiver) {
    return Reflect.get(target, prop, receiver);
}
export const woo = (obj) => {
    const hasBeenSet = {};
    Object.keys(obj).forEach(i => (hasBeenSet[i] = false));
    const t = Object.assign({}, obj);
    Object.preventExtensions(t);
    return new Proxy(t, {
        get: (target, prop, receiver) => returnValue(target, prop, receiver),
        set: function (target, prop, value) {
            if (hasBeenSet[prop] === false) {
                target[prop] = value;
                hasBeenSet[prop] = true;
                if (Object.values(hasBeenSet).every(i => i == true)) {
                    Object.freeze(t);
                }
                return true;
            }
            return false;
        },
    });
};
//# sourceMappingURL=index.js.map